<?php
/**
 * Architectonic Structure Theme Customizer.
 *
 * @link https://developer.wordpress.org/themes/basics/theme-functions/
 *
 * @package architectonic_structure
 */

if( ! function_exists( 'architectonic_structure_customize_register' ) ):  
/**
 * Add postMessage support for site title and description for the Theme Customizer.F
 *
 * @param WP_Customize_Manager $wp_customize Theme Customizer object.
 */
function architectonic_structure_customize_register( $wp_customize ) {
    require get_parent_theme_file_path('/inc/controls/changeable-icon.php');

    require get_parent_theme_file_path('/inc/controls/sortable-control.php');
    
    //Register the sortable control type.
    $wp_customize->register_control_type( 'Architectonic_Structure_Control_Sortable' ); 
    

    if ( version_compare( get_bloginfo('version'),'4.9', '>=') ) {
        $wp_customize->get_section( 'static_front_page' )->title = __( 'Static Front Page', 'architectonic-structure' );
    }
	
    /* Option list of all post */	
    $architectonic_structure_options_posts = array();
    $architectonic_structure_options_posts_obj = get_posts('posts_per_page=-1');
    $architectonic_structure_options_posts[''] = esc_html__( 'Choose Post', 'architectonic-structure' );
    foreach ( $architectonic_structure_options_posts_obj as $architectonic_structure_posts ) {
    	$architectonic_structure_options_posts[$architectonic_structure_posts->ID] = $architectonic_structure_posts->post_title;
    }
    
    /* Option list of all categories */
    $architectonic_structure_args = array(
	   'type'                     => 'post',
	   'orderby'                  => 'name',
	   'order'                    => 'ASC',
	   'hide_empty'               => 1,
	   'hierarchical'             => 1,
	   'taxonomy'                 => 'category'
    ); 
    $architectonic_structure_option_categories = array();
    $architectonic_structure_category_lists = get_categories( $architectonic_structure_args );
    $architectonic_structure_option_categories[''] = esc_html__( 'Choose Category', 'architectonic-structure' );
    foreach( $architectonic_structure_category_lists as $architectonic_structure_category ){
        $architectonic_structure_option_categories[$architectonic_structure_category->term_id] = $architectonic_structure_category->name;
    }
    
    /** Default Settings */    
    $wp_customize->add_panel( 
        'wp_default_panel',
         array(
            'priority' => 10,
            'capability' => 'edit_theme_options',
            'theme_supports' => '',
            'title' => esc_html__( 'Default Settings', 'architectonic-structure' ),
            'description' => esc_html__( 'Default section provided by wordpress customizer.', 'architectonic-structure' ),
        ) 
    );
    
    $wp_customize->get_section( 'title_tagline' )->panel                  = 'wp_default_panel';
    $wp_customize->get_section( 'colors' )->panel                         = 'wp_default_panel';
    $wp_customize->get_section( 'header_image' )->panel                   = 'wp_default_panel';
    $wp_customize->get_section( 'background_image' )->panel               = 'wp_default_panel';
    $wp_customize->get_section( 'static_front_page' )->panel              = 'wp_default_panel';
    
    $wp_customize->get_setting( 'blogname' )->transport         = 'postMessage';
	$wp_customize->get_setting( 'blogdescription' )->transport  = 'postMessage';
	$wp_customize->get_setting( 'header_textcolor' )->transport = 'postMessage';
    
    /** Default Settings Ends */
    
    /** Site Title control */
    $wp_customize->add_setting( 
        'header_site_title', 
        array(
            'default'           => true,
            'sanitize_callback' => 'architectonic_structure_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'header_site_title',
        array(
            'label'       => __( 'Show / Hide Site Title', 'architectonic-structure' ),
            'section'     => 'title_tagline',
            'type'        => 'checkbox',
        )
    );

    /** Tagline control */
    $wp_customize->add_setting( 
        'header_tagline', 
        array(
            'default'           => false,
            'sanitize_callback' => 'architectonic_structure_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'header_tagline',
        array(
            'label'       => __( 'Show / Hide Tagline', 'architectonic-structure' ),
            'section'     => 'title_tagline',
            'type'        => 'checkbox',
        )
    );

    $wp_customize->add_setting('logo_width', array(
        'sanitize_callback' => 'absint', 
    ));

    // Add a control for logo width
    $wp_customize->add_control('logo_width', array(
        'label' => __('Logo Width', 'architectonic-structure'),
        'section' => 'title_tagline',
        'type' => 'number',
        'input_attrs' => array(
            'min' => '50', 
            'max' => '500', 
            'step' => '5', 
    ),
        'default' => '100', 
    ));

    $wp_customize->add_setting( 'architectonic_structure_site_title_size', array(
        'default'           => 24, // Default font size in pixels
        'sanitize_callback' => 'absint', // Sanitize the input as a positive integer
    ) );

    // Add control for site title size
    $wp_customize->add_control( 'architectonic_structure_site_title_size', array(
        'type'        => 'number',
        'section'     => 'title_tagline', // You can change this section to your preferred section
        'label'       => __( 'Site Title Font Size', 'architectonic-structure' ),
        'input_attrs' => array(
            'min'  => 10,
            'max'  => 100,
            'step' => 1,
        ),
    ) );

    /** Post & Pages Settings */
    $wp_customize->add_panel( 
        'architectonic_structure_post_settings',
         array(
            'priority' => 11,
            'capability' => 'edit_theme_options',
            'title' => esc_html__( 'Post & Pages Settings', 'architectonic-structure' ),
            'description' => esc_html__( 'Customize Post & Pages Settings', 'architectonic-structure' ),
        ) 
    );

        /** Post Layouts */
    
    $wp_customize->add_section(
        'architectonic_structure_post_layout_section',
        array(
            'title' => esc_html__( 'Post Layout Settings', 'architectonic-structure' ),
            'priority' => 20,
            'capability' => 'edit_theme_options',
            'panel' => 'architectonic_structure_post_settings',
        )
    );

    $wp_customize->add_setting('architectonic_structure_post_layout_setting', array(
        'default'           => 'right-sidebar',
        'sanitize_callback' => 'architectonic_structure_sanitize_post_layout',
    ));

    $wp_customize->add_control('architectonic_structure_post_layout_setting', array(
        'label'    => __('Post Column Settings', 'architectonic-structure'),
        'section'  => 'architectonic_structure_post_layout_section',
        'settings' => 'architectonic_structure_post_layout_setting',
        'type'     => 'select',
        'choices'  => array(
            'one-column'   => __('One Column', 'architectonic-structure'),
            'right-sidebar'   => __('Right Sidebar', 'architectonic-structure'),
            'left-sidebar'   => __('Left Sidebar', 'architectonic-structure'),
            'three-column'   => __('Three Columns', 'architectonic-structure'),
            'four-column'   => __('Four Columns', 'architectonic-structure'),
        ),
    ));

     /** Post Layouts Ends */
     
    /** Post Settings */
    $wp_customize->add_section(
        'architectonic_structure_post_settings',
        array(
            'title' => esc_html__( 'Post Settings', 'architectonic-structure' ),
            'priority' => 20,
            'capability' => 'edit_theme_options',
            'panel' => 'architectonic_structure_post_settings',
        )
    );

    /** Post Heading control */
    $wp_customize->add_setting( 
        'architectonic_structure_post_heading_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'architectonic_structure_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'architectonic_structure_post_heading_setting',
        array(
            'label'       => __( 'Show / Hide Post Heading', 'architectonic-structure' ),
            'section'     => 'architectonic_structure_post_settings',
            'type'        => 'checkbox',
        )
    );

    /** Post Meta control */
    $wp_customize->add_setting( 
        'architectonic_structure_post_meta_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'architectonic_structure_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'architectonic_structure_post_meta_setting',
        array(
            'label'       => __( 'Show / Hide Post Meta', 'architectonic-structure' ),
            'section'     => 'architectonic_structure_post_settings',
            'type'        => 'checkbox',
        )
    );

    /** Post Image control */
    $wp_customize->add_setting( 
        'architectonic_structure_post_image_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'architectonic_structure_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'architectonic_structure_post_image_setting',
        array(
            'label'       => __( 'Show / Hide Post Image', 'architectonic-structure' ),
            'section'     => 'architectonic_structure_post_settings',
            'type'        => 'checkbox',
        )
    );

    /** Post Content control */
    $wp_customize->add_setting( 
        'architectonic_structure_post_content_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'architectonic_structure_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'architectonic_structure_post_content_setting',
        array(
            'label'       => __( 'Show / Hide Post Content', 'architectonic-structure' ),
            'section'     => 'architectonic_structure_post_settings',
            'type'        => 'checkbox',
        )
    );
    /** Post ReadMore control */
     $wp_customize->add_setting( 'architectonic_structure_read_more_setting`', array(
        'default'           => true,
        'sanitize_callback' => 'architectonic_structure_sanitize_checkbox',
    ) );

    $wp_customize->add_control( 'architectonic_structure_read_more_setting`', array(
        'type'        => 'checkbox',
        'section'     => 'architectonic_structure_post_settings', 
        'label'       => __( 'Display Read More Button', 'architectonic-structure' ),
    ) );

    $wp_customize->add_setting('architectonic_structure_blog_meta_order', array(
        'default' => array('heading', 'author', 'featured-image', 'content','button'),
        'sanitize_callback' => 'architectonic_structure_sanitize_sortable',
    ));
    $wp_customize->add_control(new Architectonic_Structure_Control_Sortable($wp_customize, 'architectonic_structure_blog_meta_order', array(
        'label' => esc_html__('Post Meta Ordering', 'architectonic-structure'),
        'description' => __('Drag & drop post items to rearrange the ordering ( this control will not function by post format )', 'architectonic-structure') ,
        'section' => 'architectonic_structure_post_settings',
        'choices' => array(
            'heading' => __('heading', 'architectonic-structure') ,
            'author' => __('author', 'architectonic-structure') ,
            'featured-image' => __('featured-image', 'architectonic-structure') ,
            'content' => __('content', 'architectonic-structure') ,
            'button' => __('button', 'architectonic-structure') ,
        ) ,
    )));

    /** Post Settings Ends */

     /** Single Post Settings */
    $wp_customize->add_section(
        'architectonic_structure_single_post_settings',
        array(
            'title' => esc_html__( 'Single Post Settings', 'architectonic-structure' ),
            'priority' => 20,
            'capability' => 'edit_theme_options',
            'panel' => 'architectonic_structure_post_settings',
        )
    );

    /** Single Post Meta control */
    $wp_customize->add_setting( 
        'architectonic_structure_single_post_meta_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'architectonic_structure_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'architectonic_structure_single_post_meta_setting',
        array(
            'label'       => __( 'Show / Hide Single Post Meta', 'architectonic-structure' ),
            'section'     => 'architectonic_structure_single_post_settings',
            'type'        => 'checkbox',
        )
    );

    /** Single Post Content control */
    $wp_customize->add_setting( 
        'architectonic_structure_single_post_content_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'architectonic_structure_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'architectonic_structure_single_post_content_setting',
        array(
            'label'       => __( 'Show / Hide Single Post Content', 'architectonic-structure' ),
            'section'     => 'architectonic_structure_single_post_settings',
            'type'        => 'checkbox',
        )
    );

    //Global Color
    $wp_customize->add_section(
        'architectonic_structure_global_color',
        array(
            'title' => esc_html__( 'Global Color Settings', 'architectonic-structure' ),
            'priority' => 20,
            'capability' => 'edit_theme_options',
            'panel' => 'architectonic_structure_general_settings',
        )
    );

    $wp_customize->add_setting('architectonic_structure_primary_color', array(
        'default'           => '#10243B',
        'sanitize_callback' => 'sanitize_hex_color',
    ));
    $wp_customize->add_control(new WP_Customize_Color_Control($wp_customize, 'architectonic_structure_primary_color', array(
        'label'    => __('Theme Primary Color', 'architectonic-structure'),
        'section'  => 'architectonic_structure_global_color',
        'settings' => 'architectonic_structure_primary_color',
    )));    

    $wp_customize->add_setting('architectonic_structure_secondary_color', array(
        'default'           => '#A57E4D',
        'sanitize_callback' => 'sanitize_hex_color',
    ));
    $wp_customize->add_control(new WP_Customize_Color_Control($wp_customize, 'architectonic_structure_secondary_color', array(
        'label'    => __('Theme Secondary Color', 'architectonic-structure'),
        'section'  => 'architectonic_structure_global_color',
        'settings' => 'architectonic_structure_secondary_color',
    ))); 

    /** Single Post Settings Ends */

         // Typography Settings Section
    $wp_customize->add_section('architectonic_structure_typography_settings', array(
        'title'      => esc_html__('Typography Settings', 'architectonic-structure'),
        'priority'   => 30,
        'capability' => 'edit_theme_options',
        'panel' => 'architectonic_structure_general_settings',
    ));

    // Array of fonts to choose from
    $font_choices = array(
        ''               => __('Select', 'architectonic-structure'),
        'Arial'          => 'Arial, sans-serif',
        'Verdana'        => 'Verdana, sans-serif',
        'Helvetica'      => 'Helvetica, sans-serif',
        'Times New Roman'=> '"Times New Roman", serif',
        'Georgia'        => 'Georgia, serif',
        'Courier New'    => '"Courier New", monospace',
        'Trebuchet MS'   => '"Trebuchet MS", sans-serif',
        'Tahoma'         => 'Tahoma, sans-serif',
        'Palatino'       => '"Palatino Linotype", serif',
        'Garamond'       => 'Garamond, serif',
        'Impact'         => 'Impact, sans-serif',
        'Comic Sans MS'  => '"Comic Sans MS", cursive, sans-serif',
        'Lucida Sans'    => '"Lucida Sans Unicode", sans-serif',
        'Arial Black'    => '"Arial Black", sans-serif',
        'Gill Sans'      => '"Gill Sans", sans-serif',
        'Segoe UI'       => '"Segoe UI", sans-serif',
        'Open Sans'      => '"Open Sans", sans-serif',
        'Inter'         => 'Inter, sans-serif',
        'Lato'           => 'Lato, sans-serif',
        'Montserrat'     => 'Montserrat, sans-serif',
        'Libre Baskerville' => 'Libre Baskerville',
    );

    // Heading Font Setting
    $wp_customize->add_setting('architectonic_structure_heading_font_family', array(
        'default'           => '',
        'sanitize_callback' => 'architectonic_structure_sanitize_choicess',
    ));
    $wp_customize->add_control('architectonic_structure_heading_font_family', array(
        'type'    => 'select',
        'choices' => $font_choices,
        'label'   => __('Select Font for Heading', 'architectonic-structure'),
        'section' => 'architectonic_structure_typography_settings',
    ));

    // Body Font Setting
    $wp_customize->add_setting('architectonic_structure_body_font_family', array(
        'default'           => '',
        'sanitize_callback' => 'architectonic_structure_sanitize_choicess',
    ));
    $wp_customize->add_control('architectonic_structure_body_font_family', array(
        'type'    => 'select',
        'choices' => $font_choices,
        'label'   => __('Select Font for Body', 'architectonic-structure'),
        'section' => 'architectonic_structure_typography_settings',
    ));

    /** Typography Settings Section End */

    /** General Settings */
    $wp_customize->add_panel( 
        'architectonic_structure_general_settings',
         array(
            'priority' => 11,
            'capability' => 'edit_theme_options',
            'title' => esc_html__( 'General Settings', 'architectonic-structure' ),
            'description' => esc_html__( 'Customize General Settings', 'architectonic-structure' ),
        ) 
    );

    /** General Settings */
    $wp_customize->add_section(
        'architectonic_structure_general_settings',
        array(
            'title' => esc_html__( 'Loader Settings', 'architectonic-structure' ),
            'priority' => 30,
            'capability' => 'edit_theme_options',
            'panel' => 'architectonic_structure_general_settings',
        )
    );

    /** Preloader control */
    $wp_customize->add_setting( 
        'architectonic_structure_header_preloader', 
        array(
            'default' => false,
            'sanitize_callback' => 'architectonic_structure_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'architectonic_structure_header_preloader',
        array(
            'label'       => __( 'Show Preloader', 'architectonic-structure' ),
            'section'     => 'architectonic_structure_general_settings',
            'type'        => 'checkbox',
        )
    );

    $wp_customize->add_setting('architectonic_structure_loader_layout_setting', array(
        'default' => 'load',
        'sanitize_callback' => 'sanitize_text_field',
    ));

    // Add control for loader layout
    $wp_customize->add_control('architectonic_structure_loader_layout_control', array(
        'label' => __('Preloader Layout', 'architectonic-structure'),
        'section' => 'architectonic_structure_general_settings',
        'settings' => 'architectonic_structure_loader_layout_setting',
        'type' => 'select',
        'choices' => array(
            'load' => __('Preloader 1', 'architectonic-structure'),
            'load-one' => __('Preloader 2', 'architectonic-structure'),
            'ctn-preloader' => __('Preloader 3', 'architectonic-structure'),
        ),
    ));

    /** Header Section Settings */
    $wp_customize->add_section(
        'architectonic_structure_header_section_settings',
        array(
            'title' => esc_html__( 'Header Section Settings', 'architectonic-structure' ),
            'priority' => 30,
            'capability' => 'edit_theme_options',
            'panel' => 'architectonic_structure_home_page_settings',
        )
    );

    /** Sticky Header control */
    $wp_customize->add_setting( 
        'architectonic_structure_sticky_header', 
        array(
            'default' => false,
            'sanitize_callback' => 'architectonic_structure_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'architectonic_structure_sticky_header',
        array(
            'label'       => __( 'Show Sticky Header', 'architectonic-structure' ),
            'section'     => 'architectonic_structure_header_section_settings',
            'type'        => 'checkbox',
        )
    );

    $wp_customize->add_setting( 
        'architectonic_structure_show_hide_search', 
        array(
            'default' => false ,
            'sanitize_callback' => 'architectonic_structure_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'architectonic_structure_show_hide_search',
        array(
            'label'       => __( 'Show Search Icon', 'architectonic-structure' ),
            'section'     => 'architectonic_structure_header_section_settings',
            'type'        => 'checkbox',
        )
    );
    $wp_customize->add_setting('architectonic_structure_search_icon',array(
        'default'   => 'fas fa-search',
        'sanitize_callback' => 'sanitize_text_field'
    ));
    $wp_customize->add_control(new Architectonic_Structure_Changeable_Icon(
        $wp_customize,'architectonic_structure_search_icon',array(
        'label' => __('Search Icon','architectonic-structure'),
        'transport' => 'refresh',
        'section'   => 'architectonic_structure_header_section_settings',
        'type'      => 'icon'
    )));

    /** Phone */

    // Phone Icon
    $wp_customize->add_setting('architectonic_structure_phone_icon', array(
        'default' => 'fas fa-phone-volume',
        'sanitize_callback' => 'sanitize_text_field'
    ));
    $wp_customize->add_control(new Architectonic_Structure_Changeable_Icon(
        $wp_customize,'architectonic_structure_phone_icon',array(
        'label' => __('Phone Icon','architectonic-structure'),
        'section' => 'architectonic_structure_header_section_settings',
        'type' => 'icon'
    )));

    // Phone Text
    $wp_customize->add_setting('architectonic_structure_header_phone_text', array(
        'default' => '',
        'sanitize_callback' => 'sanitize_text_field',
    ));
    $wp_customize->add_control('architectonic_structure_header_phone_text', array(
        'label' => __('Phone Text','architectonic-structure'),
        'section' => 'architectonic_structure_header_section_settings',
        'type' => 'text',
    ));

    // Phone Value
    $wp_customize->add_setting('architectonic_structure_header_phone', array(
        'default' => '',
        'sanitize_callback' => 'sanitize_text_field',
    ));
    $wp_customize->add_control('architectonic_structure_header_phone', array(
        'label' => __('Add Phone','architectonic-structure'),
        'section' => 'architectonic_structure_header_section_settings',
        'type' => 'text',
    ));

    $wp_customize->add_setting( 
        'architectonic_structure_show_hide_toggle', 
        array(
            'default' => false ,
            'sanitize_callback' => 'architectonic_structure_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'architectonic_structure_show_hide_toggle',
        array(
            'label'       => __( 'Show Toggle', 'architectonic-structure' ),
            'section'     => 'architectonic_structure_header_section_settings',
            'type'        => 'checkbox',
        )
    );

    // Add Setting for Menu Font Weight
    $wp_customize->add_setting( 'architectonic_structure_menu_font_weight', array(
        'default'           => '500',
        'sanitize_callback' => 'architectonic_structure_sanitize_font_weight',
    ) );

    // Add Control for Menu Font Weight
    $wp_customize->add_control( 'architectonic_structure_menu_font_weight', array(
        'label'    => __( 'Menu Font Weight', 'architectonic-structure' ),
        'section'  => 'architectonic_structure_header_section_settings',
        'type'     => 'select',
        'choices'  => array(
            '100' => __( '100 - Thin', 'architectonic-structure' ),
            '200' => __( '200 - Extra Light', 'architectonic-structure' ),
            '300' => __( '300 - Light', 'architectonic-structure' ),
            '400' => __( '400 - Normal', 'architectonic-structure' ),
            '500' => __( '500 - Medium', 'architectonic-structure' ),
            '600' => __( '600 - Semi Bold', 'architectonic-structure' ),
            '700' => __( '700 - Bold', 'architectonic-structure' ),
            '800' => __( '800 - Extra Bold', 'architectonic-structure' ),
            '900' => __( '900 - Black', 'architectonic-structure' ),
        ),
    ) );

    // Add Setting for Menu Text Transform
    $wp_customize->add_setting( 'architectonic_structure_menu_text_transform', array(
        'default'           => 'uppercase',
        'sanitize_callback' => 'architectonic_structure_sanitize_text_transform',
    ) );

    // Add Control for Menu Text Transform
    $wp_customize->add_control( 'architectonic_structure_menu_text_transform', array(
        'label'    => __( 'Menu Text Transform', 'architectonic-structure' ),
        'section'  => 'architectonic_structure_header_section_settings',
        'type'     => 'select',
        'choices'  => array(
            'none'       => __( 'None', 'architectonic-structure' ),
            'capitalize' => __( 'Capitalize', 'architectonic-structure' ),
            'uppercase'  => __( 'Uppercase', 'architectonic-structure' ),
            'lowercase'  => __( 'Lowercase', 'architectonic-structure' ),
        ),
    ) );

    // Menu Hover Style	
    $wp_customize->add_setting('architectonic_structure_menus_style',array(
        'default' => '',
        'sanitize_callback' => 'architectonic_structure_sanitize_choices'
	));
	$wp_customize->add_control('architectonic_structure_menus_style',array(
        'type' => 'select',
		'label' => __('Menu Hover Style','architectonic-structure'),
		'section' => 'architectonic_structure_header_section_settings',
		'choices' => array(
         'None' => __('None','architectonic-structure'),
         'Zoom In' => __('Zoom In','architectonic-structure'),
      ),
	));

    /** Home Page Settings */
    $wp_customize->add_panel( 
        'architectonic_structure_home_page_settings',
         array(
            'priority' => 9,
            'capability' => 'edit_theme_options',
            'title' => esc_html__( 'Home Page Settings', 'architectonic-structure' ),
            'description' => esc_html__( 'Customize Home Page Settings', 'architectonic-structure' ),
        ) 
    );

    $wp_customize->add_section(
        'architectonic_structure_banner_section_settings',
        array(
            'title' => esc_html__( 'Banner Settings', 'architectonic-structure' ),
            'priority' => 30,
            'capability' => 'edit_theme_options',
            'panel' => 'architectonic_structure_home_page_settings',
        )
    );
    /** Banner Section Settings */
    $wp_customize->add_section(
        'architectonic_structure_banner_section_settings',
        array(
            'title' => esc_html__( 'Banner Section Settings', 'architectonic-structure' ),
            'priority' => 30,
            'capability' => 'edit_theme_options',
            'panel' => 'architectonic_structure_home_page_settings',
        )
    );

    /** Banner Section control */
    $wp_customize->add_setting( 
        'architectonic_structure_banner_setting', 
        array(
            'default' => false,
            'sanitize_callback' => 'architectonic_structure_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'architectonic_structure_banner_setting',
        array(
            'label'       => __( 'Show Banner', 'architectonic-structure' ),
            'section'     => 'architectonic_structure_banner_section_settings',
            'type'        => 'checkbox',
        )
    );

    // Section Text
    $wp_customize->add_setting('architectonic_structure_banner_text_extra', 
        array(
        'default'           => '',
        'type'              => 'theme_mod',
        'capability'        => 'edit_theme_options',    
        'sanitize_callback' => 'sanitize_text_field'
        )
    );

    $wp_customize->add_control('architectonic_structure_banner_text_extra', 
        array(
        'label'       => __('Banner Sub Title', 'architectonic-structure'),
        'section'     => 'architectonic_structure_banner_section_settings',   
        'settings'    => 'architectonic_structure_banner_text_extra',
        'type'        => 'text'
        )
    );

    // Section Text
    $wp_customize->add_setting('architectonic_structure_banner_title', 
        array(
        'default'           => '',
        'type'              => 'theme_mod',
        'capability'        => 'edit_theme_options',    
        'sanitize_callback' => 'sanitize_text_field'
        )
    );

    $wp_customize->add_control('architectonic_structure_banner_title', 
        array(
        'label'       => __('Banner Title', 'architectonic-structure'),
        'section'     => 'architectonic_structure_banner_section_settings',   
        'settings'    => 'architectonic_structure_banner_title',
        'type'        => 'text'
        )
    );

    $wp_customize->add_setting('architectonic_structure_banner_content', 
        array(
        'default'           => '',
        'type'              => 'theme_mod',
        'capability'        => 'edit_theme_options',    
        'sanitize_callback' => 'sanitize_text_field'
        )
    );

    $wp_customize->add_control('architectonic_structure_banner_content', 
        array(
        'label'       => __('Banner Content', 'architectonic-structure'),
        'section'     => 'architectonic_structure_banner_section_settings',   
        'settings'    => 'architectonic_structure_banner_content',
        'type'        => 'text'
        )
    );

    // banner button Text
    $wp_customize->add_setting('architectonic_structure_banner_btn_text', 
        array(
        'default'           => '',
        'type'              => 'theme_mod',
        'capability'        => 'edit_theme_options',    
        'sanitize_callback' => 'sanitize_text_field'
        )
    );

    $wp_customize->add_control('architectonic_structure_banner_btn_text', 
        array(
        'label'       => __('Banner Button Text', 'architectonic-structure'),
        'section'     => 'architectonic_structure_banner_section_settings',   
        'settings'    => 'architectonic_structure_banner_btn_text',
        'type'        => 'text'
        )
    );

    // banner button Url
    $wp_customize->add_setting('architectonic_structure_banner_btn_url', 
        array(
        'default'           => '',
        'type'              => 'theme_mod',
        'capability'        => 'edit_theme_options',    
        'sanitize_callback' => 'esc_url_raw'
        )
    );

    $wp_customize->add_control('architectonic_structure_banner_btn_url', 
        array(
        'label'       => __('Banner Button URL', 'architectonic-structure'),
        'section'     => 'architectonic_structure_banner_section_settings',   
        'settings'    => 'architectonic_structure_banner_btn_url',
        'type'        => 'url'
        )
    );

    $wp_customize->add_setting('architectonic_structure_banner_background_image', array(
        'default'           => get_template_directory_uri() . '/images/default.png',
        'sanitize_callback' => 'esc_url_raw',
    ));

    $wp_customize->add_control(new WP_Customize_Image_Control($wp_customize, 'architectonic_structure_banner_background_image', array(
        'label' => __('Banner Background Image', 'architectonic-structure'),
        'section' => 'architectonic_structure_banner_section_settings',
        'settings' => 'architectonic_structure_banner_background_image',
    )));

    /** Socail Section control */
    $wp_customize->add_setting( 
        'architectonic_structure_social_icon_setting', 
        array(
            'default' => false,
            'sanitize_callback' => 'architectonic_structure_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'architectonic_structure_social_icon_setting',
        array(
            'label'       => __( 'Show Social Icon', 'architectonic-structure' ),
            'section'     => 'architectonic_structure_banner_section_settings',
            'type'        => 'checkbox',
        )
    );

    /**  Social Link 2 */
    $wp_customize->add_setting(
        'architectonic_structure_social_link_2',
        array( 
            'default' => '',
            'sanitize_callback' => 'esc_url_raw',
            'transport'         => 'refresh'
        )
    );
    
    $wp_customize->add_control(
        'architectonic_structure_social_link_2',
        array(
            'label' => esc_html__( 'Add Instagram Link', 'architectonic-structure' ),
            'section' => 'architectonic_structure_banner_section_settings',
            'type' => 'url',
        )
    );

    /**  Social Link 1 */
    $wp_customize->add_setting(
        'architectonic_structure_social_link_1',
        array( 
            'default' => '',
            'sanitize_callback' => 'esc_url_raw',
            'transport'         => 'refresh'
        )
    );
    
    $wp_customize->add_control(
        'architectonic_structure_social_link_1',
        array(
            'label' => esc_html__( 'Add Facebook Link', 'architectonic-structure' ),
            'section' => 'architectonic_structure_banner_section_settings',
            'type' => 'url',
        )
    );

    /**  Social Link 3 */
    $wp_customize->add_setting(
        'architectonic_structure_social_link_3',
        array( 
            'default' => '',
            'sanitize_callback' => 'esc_url_raw',
            'transport'         => 'refresh'
        )
    );
    
    $wp_customize->add_control(
        'architectonic_structure_social_link_3',
        array(
            'label' => esc_html__( 'Add Twitter Link', 'architectonic-structure' ),
            'section' => 'architectonic_structure_banner_section_settings',
            'type' => 'url',
        )
    );

    /**  Social Link 4 */
    $wp_customize->add_setting(
        'architectonic_structure_social_link_4',
        array( 
            'default' => '',
            'sanitize_callback' => 'esc_url_raw',
            'transport'         => 'refresh'
        )
    );
    
    $wp_customize->add_control(
        'architectonic_structure_social_link_4',
        array(
            'label' => esc_html__( 'Add Linkedin Link', 'architectonic-structure' ),
            'section' => 'architectonic_structure_banner_section_settings',
            'type' => 'url',
        )
    );

    /**  Social Link 4 */
    $wp_customize->add_setting(
        'architectonic_structure_social_link_5',
        array( 
            'default' => '',
            'sanitize_callback' => 'esc_url_raw',
            'transport'         => 'refresh'
        )
    );
    
    $wp_customize->add_control(
        'architectonic_structure_social_link_5',
        array(
            'label' => esc_html__( 'Add Youtube Link', 'architectonic-structure' ),
            'section' => 'architectonic_structure_banner_section_settings',
            'type' => 'url',
        )
    );

    /** Social Section Settings End */

        $wp_customize->add_setting( 
        'architectonic_structure_project_setting', 
        array(
            'default' => false,
            'sanitize_callback' => 'architectonic_structure_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'architectonic_structure_project_setting',
        array(
            'label'       => __( 'Show Project Section', 'architectonic-structure' ),
            'section'     => 'architectonic_structure_banner_section_settings',
            'type'        => 'checkbox',
        )
    );

    // Post Categories
    $architectonic_structure_categories = get_categories();
    $architectonic_structure_cat_posts = array();
    $architectonic_structure_default = '';
    $architectonic_structure_cat_posts[] = 'Select';
    foreach ($architectonic_structure_categories as $architectonic_structure_category) {
        $architectonic_structure_cat_posts[$architectonic_structure_category->slug] = $architectonic_structure_category->name;
    }

    $wp_customize->add_setting(
        'architectonic_structure_project_args_',
        array(
            'default'            => 'select',
            'sanitize_callback'  => 'architectonic_structure_sanitize_choices',
        )
    );
    $wp_customize->add_control(
        'architectonic_structure_project_args_',
        array(
            'type'     => 'select',
            'choices'  => $architectonic_structure_cat_posts,
            'label'    => __('Select Category to Display Services', 'architectonic-structure'),
            'section'  => 'architectonic_structure_banner_section_settings',
        )
    );

    /** Classes Section Settings */
   $wp_customize->add_section(
        'architectonic_structure_classes_section_settings',
        array(
            'title' => esc_html__( 'Services Section Settings', 'architectonic-structure' ),
            'priority' => 30,
            'capability' => 'edit_theme_options',
            'panel' => 'architectonic_structure_home_page_settings',
        )
    );

    /** Classes Section control */
    $wp_customize->add_setting( 
        'architectonic_structure_classes_setting', 
        array(
            'default' => false,
            'sanitize_callback' => 'architectonic_structure_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'architectonic_structure_classes_setting',
        array(
            'label'       => __( 'Show Services Section', 'architectonic-structure' ),
            'section'     => 'architectonic_structure_classes_section_settings',
            'type'        => 'checkbox',
        )
    );

    // Section Title
    $wp_customize->add_setting(
        'architectonic_structure_service_title', 
        array(
            'default'           => '',
            'type'              => 'theme_mod',
            'capability'        => 'edit_theme_options',    
            'sanitize_callback' => 'sanitize_text_field'
        )
    );

    $wp_customize->add_control(
        'architectonic_structure_service_title', 
        array(
            'label'       => __('Section Title', 'architectonic-structure'),
            'section'     => 'architectonic_structure_classes_section_settings',
            'settings'    => 'architectonic_structure_service_title',
            'type'        => 'text'
        )
    );

     // Section Text
    $wp_customize->add_setting(
        'architectonic_structure_service_text', 
        array(
            'default'           => '',
            'type'              => 'theme_mod',
            'capability'        => 'edit_theme_options',    
            'sanitize_callback' => 'sanitize_text_field'
        )
    );

    $wp_customize->add_control(
        'architectonic_structure_service_text', 
        array(
            'label'       => __('Section Text', 'architectonic-structure'),
            'section'     => 'architectonic_structure_classes_section_settings',
            'settings'    => 'architectonic_structure_service_text',
            'type'        => 'text'
        )
    );

    // Post Categories
    $architectonic_structure_categories = get_categories();
    $architectonic_structure_cat_posts = array();
    $architectonic_structure_default = '';
    $architectonic_structure_cat_posts[] = 'Select';
    foreach ($architectonic_structure_categories as $architectonic_structure_category) {
        $architectonic_structure_cat_posts[$architectonic_structure_category->slug] = $architectonic_structure_category->name;
    }

    $wp_customize->add_setting(
        'architectonic_structure_blog_args_',
        array(
            'default'            => 'select',
            'sanitize_callback'  => 'architectonic_structure_sanitize_choices',
        )
    );
    $wp_customize->add_control(
        'architectonic_structure_blog_args_',
        array(
            'type'     => 'select',
            'choices'  => $architectonic_structure_cat_posts,
            'label'    => __('Select Category to Display Services', 'architectonic-structure'),
            'section'  => 'architectonic_structure_classes_section_settings',
        )
    );


    for ($architectonic_structure_i=1; $architectonic_structure_i <= 10; $architectonic_structure_i++) {

        $wp_customize->add_setting('architectonic_structure_category_icon'.$architectonic_structure_i,array(
            'default'   => '',
            'sanitize_callback' => 'sanitize_text_field'
        ));
        $wp_customize->add_control(new Architectonic_Structure_Changeable_Icon(
            $wp_customize,'architectonic_structure_category_icon'.$architectonic_structure_i,array(
            'label' => __('Feature Icon ','architectonic-structure').$architectonic_structure_i,
            'transport' => 'refresh',
            'section'   => 'architectonic_structure_classes_section_settings',
            'type'      => 'icon'
        )));
    }
    
    /** Home Page Settings Ends */
    
    /** Footer Section */
    $wp_customize->add_section(
        'architectonic_structure_footer_section',
        array(
            'title' => __( 'Footer Settings', 'architectonic-structure' ),
            'priority' => 70,
            'panel' => 'architectonic_structure_home_page_settings',
        )
    );
    
    /** Copyright Text */
    $wp_customize->add_setting(
        'architectonic_structure_footer_copyright_text',
        array(
            'default' => '',
            'sanitize_callback' => 'sanitize_text_field',
        )
    );
    
    $wp_customize->add_control(
        'architectonic_structure_footer_copyright_text',
        array(
            'label' => __( 'Copyright Info', 'architectonic-structure' ),
            'section' => 'architectonic_structure_footer_section',
            'type' => 'text',
        )
    );  
$wp_customize->add_setting('architectonic_structure_footer_background_image',
        array(
        'default' => '',
        'capability' => 'edit_theme_options',
        'sanitize_callback' => 'absint',
        )
    );


    $wp_customize->add_control(
         new WP_Customize_Cropped_Image_Control($wp_customize, 'architectonic_structure_footer_background_image',
            array(
                'label' => esc_html__('Footer Background Image', 'architectonic-structure'),
                /* translators: 1: image width in pixels, 2: image height in pixels */
                'description' => sprintf(esc_html__('Recommended Size %1$s px X %2$s px', 'architectonic-structure'), 1024, 800),
                'section' => 'architectonic_structure_footer_section',
                'width' => 1024,
                'height' => 800,
                'flex_width' => true,
                'flex_height' => true,
            )
        )
    );

    /** Footer Background Image Attachment */
    $wp_customize->add_setting('architectonic_structure_background_attachment', array(
        'default'           => 'scroll',
        'sanitize_callback' => 'architectonic_structure_sanitize_choices',
    ));

    $wp_customize->add_control('architectonic_structure_background_attachment', array(
        'label'    => __('Footer Background Attachment', 'architectonic-structure'),
        'section'  => 'architectonic_structure_footer_section',
        'settings' => 'architectonic_structure_background_attachment',
        'type'     => 'select',
        'choices'  => array(
            'fixed' => __('fixed','architectonic-structure'),
            'scroll' => __('scroll','architectonic-structure'),
        ),
    ));

    /* Footer Background Color*/
    $wp_customize->add_setting(
        'architectonic_structure_footer_background_color',
        array(
            'default' => '',
            'sanitize_callback' => 'sanitize_hex_color',
        )
    );
    $wp_customize->add_control(
        new WP_Customize_Color_Control(
            $wp_customize,
            'architectonic_structure_footer_background_color',
            array(
                'label' => __('Footer Widget Area Background Color', 'architectonic-structure'),
                'section' => 'architectonic_structure_footer_section',
                'type' => 'color',
            )
        )
    );

     $wp_customize->add_setting('architectonic_structure_scroll_icon',array(
        'default'   => 'fas fa-arrow-up',
        'sanitize_callback' => 'sanitize_text_field'
    ));
    $wp_customize->add_control(new Architectonic_Structure_Changeable_Icon(
        $wp_customize,'architectonic_structure_scroll_icon',array(
        'label' => __('Scroll Top Icon','architectonic-structure'),
        'transport' => 'refresh',
        'section'   => 'architectonic_structure_footer_section',
        'type'      => 'icon'
    )));

    /** Scroll to top button shape */
    $wp_customize->add_setting('architectonic_structure_scroll_to_top_radius', array(
        'default'           => 'curved-box',
        'sanitize_callback' => 'architectonic_structure_sanitize_choices',
    ));

    $wp_customize->add_control('architectonic_structure_scroll_to_top_radius', array(
        'label'    => __('Scroll Top Button Shape', 'architectonic-structure'),
        'section'  => 'architectonic_structure_footer_section',
        'settings' => 'architectonic_structure_scroll_to_top_radius',
        'type'     => 'select',
        'choices'  => array(
            'box'        => __( 'Box', 'architectonic-structure' ),
            'curved-box' => __( 'Curved Box', 'architectonic-structure' ),
            'circle'     => __( 'Circle', 'architectonic-structure' ),
        ),
    ));

    // 404 PAGE SETTINGS
    $wp_customize->add_section(
        'architectonic_structure_404_section',
        array(
            'title' => __( '404 Page Settings', 'architectonic-structure' ),
            'priority' => 70,
            'panel' => 'architectonic_structure_general_settings',
        )
    );
   
    $wp_customize->add_setting('404_page_image', array(
        'default' => '',
        'transport' => 'refresh',
        'sanitize_callback' => 'esc_url_raw', // Sanitize as URL
    ));

    $wp_customize->add_control(new WP_Customize_Image_Control($wp_customize, '404_page_image', array(
        'label' => __('404 Page Image', 'architectonic-structure'),
        'section' => 'architectonic_structure_404_section',
        'settings' => '404_page_image',
    )));

    $wp_customize->add_setting('404_pagefirst_header', array(
        'default' => __('404', 'architectonic-structure'),
        'transport' => 'refresh',
        'sanitize_callback' => 'sanitize_text_field', // Sanitize as text field
    ));

    $wp_customize->add_control('404_pagefirst_header', array(
        'type' => 'text',
        'label' => __('Heading', 'architectonic-structure'),
        'section' => 'architectonic_structure_404_section',
    ));

    // Setting for 404 page header
    $wp_customize->add_setting('404_page_header', array(
        'default' => __('Sorry, that page can\'t be found!', 'architectonic-structure'),
        'transport' => 'refresh',
        'sanitize_callback' => 'sanitize_text_field', // Sanitize as text field
    ));

    $wp_customize->add_control('404_page_header', array(
        'type' => 'text',
        'label' => __('Heading', 'architectonic-structure'),
        'section' => 'architectonic_structure_404_section',
    ));

}
add_action( 'customize_register', 'architectonic_structure_customize_register' );
endif;

/**
 * Binds JS handlers to make Theme Customizer preview reload changes asynchronously.
 */
function architectonic_structure_customize_preview_js() {
    // Use minified libraries if SCRIPT_DEBUG is false
    $architectonic_structure_build  = ( defined( 'SCRIPT_DEBUG' ) && SCRIPT_DEBUG ) ? '/build' : '';
    $architectonic_structure_suffix = ( defined( 'SCRIPT_DEBUG' ) && SCRIPT_DEBUG ) ? '' : '.min';
	wp_enqueue_script( 'architectonic_structure_customizer', get_template_directory_uri() . '/js' . $architectonic_structure_build . '/customizer' . $architectonic_structure_suffix . '.js', array( 'customize-preview' ), '20130508', true );
}
add_action( 'customize_preview_init', 'architectonic_structure_customize_preview_js' );